<!DOCTYPE html>
<html lang="en">

<head>
    <title>GradeBook</title>
</head>
<style>
    body {
        background-color: #CCCCCC;
        font-size: 25px;
    }

    table {
        color: black;
        font-size: 25px;
    }
</style>

<body>
    <h1>GradeBook</h1>

    <?php
    session_start();
    require_once('GradeBook.php');

    // Check if the user is in
    if (!isset($_SESSION['logged_in']) || $_SESSION['logged_in'] !== true) {
        header("Location: login.php");
        exit();
    }

    // Get student table
    $students = getStudents();

    if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['editIndex'])) {
        // Handle edit
        $editIndex = $_POST['editIndex'];
        displayEditForm($students[$editIndex], $editIndex);
    } elseif ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['delete'])) {
        // Handle delete
        Delete($students, $_POST['delete']);
    } else {
        // Handle add
        handleForm($students);
    }

    // show table
    showStudentTable($students);
    ?>


    <h2>Add Student</h2>
    <form method="post" action="index.php">
        <label for="StudentName">Student Name</label>
        <input type="Text" name="StudentName" required>

        <label for="Grade"> Student Grade:</label>
        <input type="number" name="Grade" required min="0" max="100">

        <label for="StartDate"> Start Date:</label>
        <input type="text" name="StartDate" required pattern="\d{2}/\d{2}/\d{2}" placeholder="MM/DD/YY">

        <label for="EndDate"> End Date:</label>
        <input type="text" name="EndDate" pattern="\d{2}/\d{2}/\d{2}" placeholder="MM/DD/YY">

        <button type="submit">Add Student</button>
    </form>
    <form method="post" action="index.php">
        <button type="submit" name="logout">Logout</button>
    </form>
</body>

</html>

<?php
function displayEditForm($student, $editIndex)
{
    if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['saveChanges'])) {
        //edit but it doesnt work for some reason
        Edit($students, $editIndex);
    }
    ?>
    <h2>Edit Student</h2>
    <form method="post" action="">
        <input type="hidden" name="editIndex" value="<?php echo $editIndex; ?>">
        <label for="StudentName">Student Name</label>
        <input type="text" name="StudentName" value="<?php echo $student['name']; ?>" required>

        <label for="Grade"> Student Grade:</label>
        <input type="number" name="Grade" value="<?php echo $student['grade']; ?>" required min="0" max="100">

        <label for="StartDate"> Start Date:</label>
        <input type="text" name="StartDate" value="<?php echo $student['StartDate']; ?>" required
            pattern="\d{2}/\d{2}/\d{2}" placeholder="MM/DD/YY">

        <label for="EndDate"> End Date:</label>
        <input type="text" name="EndDate" value="<?php echo $student['EndDate']; ?>" pattern="\d{2}/\d{2}/\d{2}"
            placeholder="MM/DD/YY">

        <button type="submit" name="saveChanges">Save Changes</button>
    </form>
    <?php
}

?>
